﻿//【登録場所】 全体、レス表示
//【ラベル】　 　レスタブすべてのIDランキング
//【コマンド1】　${SCRIPT:Frw} idrank.js　30位以内のレス数ランキング(デフォルトの場合、【コマンド2】の保存により変わる。)
//【コマンド2】　${SCRIPT:Frw} idrank.js input　ランキング表示の設定
//【コマンド3】　${SCRIPT:Frw} idrank.js input respane　【コマンド1,2】後「respane」有りで別タブ表示、無しでポップアップ表示
//※コピーボタンを削除したい場合は、222行目を削除、または行頭に『//』を追加してください。
//【更新日】 2010/11/09
//【元URL】 http://yy61.60.kg/test/read.cgi/v2cj/1252074124/126-127,209,216,231,570,581
//【スクリプト】
// ----- 次の行から -----
var vcx = v2c.context;
var vrpx = v2c.resPane;
var GraphString = '';
var mres = new Array(); //グラフ用IDデータ
var res_pane = false;

//デフォルト値
	var threshold = 30; //ID順位の閾値（閾値より低い順位はポップアップ表示しない）
	var sort_column = 0; //ソートカラム（0:レス数、1:被参照数、2:文字数、3:リンク数、4:NGレス数）
	var limited_bar = 100; //レス数と被参照数の棒グラフにおけるバー長さの制限数、超えると改行
	var save_and_submit = false; //実行ボタンをおした場合でもチェック対象のデータを保存
	
	//表示カラム（レス数、被参照数、文字数、リンク数、NGレス数）
	var view_column = ['checked', 'checked', 'checked', 'checked', ''];//'checked'であらかじめチェック
	
	//グラフの色（ポップアップの背景色, ヘッダーの背景色, 偶数行の背景色, レス番号の色, グラフバーの色, フッターの背景色）
	var color = {popup:'#F5F5F5', header:'#808080', evenrows:'#DCDCDC', resnum:'#404040', bar:'#696969', footer:'#808080'};
	
	//現在の日時
	var present = new Date();
	var py = present.getFullYear();
	var po = parseInt(present.getMonth()+1);
	var pd = present.getDate();
	var ph = present.getHours();
	var pm = present.getMinutes();
	var ps = present.getSeconds();
	var today = new Date(py,po-1,pd);
	
	//データの取得を開始する日時
	var start = [py, po, pd, 0, 0, 0];
	
	//データの取得を終了する日時
	var end = [py, po, pd, ph, pm, ps];
	
	//保存するデータ
	var temp_settings = ['', '', '', ''];

//Tableを表示のままの並びでコピー
function copyTable( str ) {
	return vcx.setClipboardText( str.replace( /<!--[^]{0,}?-->/ig, '').replace( /<[^<>]{0,}>/ig, function( a ) {
			if( a == '</tr>' || a.indexOf('<table ') > -1 )
				return '\n';
			else if ( a == '</th>' || a == '</td>' )
				return '　';
			else
				return '';
			} ).replace( /( |　|&nbsp;){1,}/ig, '　') );
}
//保存用データ作成・読み込み
var txt = v2c.getScriptDataFile( 'idrank.txt' ), cecd = 'utf-8', fs = java.io.File.separator;
if ( v2c.readFile( txt ) == null ) {
	var MenuList = ["[TempSettings]","StartTime=","EndTime=","Threshold=","SortColumn=","ViewColumn="];
	v2c.writeLinesToFile( txt, MenuList, cecd );
} else {
	var sw = 0, mt, cmdArr = v2c.readLinesFromFile( txt, cecd );
	for ( var i = 0, il = cmdArr.length; i < il; i++ ) {
		cmdArr[i] = cmdArr[i] + '';
		if ( cmdArr[i].indexOf( "[TempSettings]" ) != -1 ) sw = 1;
		else {
			switch( sw ) {
				case 1:
					mt = cmdArr[i].match( /^(StartTime|EndTime|Threshold|SortColumn|ViewColumn)=(.+)$/ );
					if( !mt ) continue;
					if( mt[1] == 'StartTime' ) { start = mt[2].split(','); temp_settings[0] = 'checked'; }
					else if( mt[1] == 'EndTime' ) { end = mt[2].split(','); temp_settings[1] = 'checked'; }
					else if( mt[1] == 'Threshold' ) { threshold = mt[2]; temp_settings[2] = 'checked'; }
					else if( mt[1] == 'SortColumn' ) sort_column = mt[2];
					else if( mt[1] == 'ViewColumn' ) { view_column = mt[2].split(','); temp_settings[3] = 'checked'; }
					break;
				default:
			}
		}
	}
}

//同一IDデータがあるかチェック、あればインデックス番号を返す
function checkSearchID( id ) {
	for ( var i = mres.length-1; i >= 0; i-- ) {
		if( mres[i].id == id ){
			return i;
		}
	}
	return null;
}

//順位のチェック
function checkSameRank( pc, c, n ) {
	if( c == 0 ){ //データが0
		return null;
	} else if( pc == c ) { //同順位
		return n+1;
	} else { //単独順位
		pc = c;
		return 0;
	}
}

//日時のフォーマット（ポップアップ文字用）
function toMyLocaleString( t ){
	var d = new Date( t );
	return java.text.SimpleDateFormat( 'yyyy/MM/dd HH:mm:ss' ).format( d );
}
//ポップアップグラフの表示
function createIdRankGraph( st, et ) {
	var thx
	var resx;
	var time = 0;
	var k = 0;
	var sid = '';
	var sres = 0;
	var sref = 0;
	var schar = 0;
	var slink = 0;
	var sng = 0;
	var res_count=0;
	var ref_count=0;
	var char_count=0;
	var link_count=0;
	var ng_count=0;
	var rank=1;
	var allres=0;
	
	//グラフ用IDデータの作成
	rexp = new RegExp( '^(?:[.\\+\\/\\w]{8})(?:O|P|Q|i|I|o|0|)$' );
	for ( var i = 0, il = vrpx.threads.length; i < il; i++ ) {
		thx = vrpx.getThread( i );
		sres=0;
		if ( thx ) {
			v2c.setStatus( '(' + (i + 1) + '/' + il + ') ' + thx.title + ' ………' );
			for ( var j = 0,jl = thx.localResCount; j < jl; j++ ) {
				resx = thx.getRes( j );
				if ( !resx ) continue;
				time = resx.time - 0;
				if ( time < st || time >= et ) continue;
				sid = resx.id;
				if ( !sid || sid.search( rexp ) == -1 ) continue;
				sid = ( sid + '' ).match( rexp ).pop();
				sres++;
				sref = resx.refCount;
				schar = ( resx.message + '' ).replace( /\n/g, '' ).length;
				slink = resx.links.length;
				sng = resx.ng;
				ididx=checkSearchID( sid );
				if ( ididx || ididx==0 ){
					mres[ididx].rescount++;
					mres[ididx].refcount += sref;
					if ( schar ) {
						mres[ididx].charcount += schar;
					}
					if ( slink ) {
						mres[ididx].linkcount += slink;
					}
					if ( sng ) {
						mres[ididx].ngcount++
					}
				} else {
					mres[k] = new Object();
					mres[k].id = sid;
					mres[k].rescount = 1;
					mres[k].refcount = sref;
					schar ? mres[k].charcount = schar : mres[k].charcount = 0;
					slink ? mres[k].linkcount = slink : mres[k].linkcount = 0;
					sng ? mres[k].ngcount = 1 : mres[k].ngcount = 0;
					k++;
				}
			}
			allres += sres;
		}
	}
	
	//グラフ用IDデータのソート
	switch(sort_column){
		case '1' : //被参照数
			mres.sort( function( a, b ) { return b.refcount - a.refcount; } );
			break;
		case '2' : //文字数
			mres.sort( function( a, b ) { return b.charcount - a.charcount; } );
			break;
		case '3' : //リンク数
			mres.sort( function( a, b ) { return b.linkcount - a.linkcount; } );
			break;
		case '4' : //ＮＧレス数
			mres.sort( function( a, b ) { return b.ngcount - a.ngcount; } );
			break;
		default : //レス数
			mres.sort( function( a, b ) { return b.rescount - a.rescount; } );
			break;
	}
	
	//グラフの作成
	var ml = mres.length;
	var gs0 = new Array( ml + 6 );
	var gsa = new Array( 19 );
	for ( var s = 0, hc = ['','','','','','','','','','']; s < 5; s++ ) {
		if ( view_column[s] != 'checked' ) {
			hc[s] = '!--';
			hc[s+5] = '--';
		}
	}
	gs0[0] = '<html><head>';
	gs0[1] = '<style type="text/css"><!--'
			+ 'body{background-color:' + color.popup + '; margin:5px 0 5px 15px; font-size:10px;}'
			+ '.period{margin:0 15px 0 0; font-weight:bold; text-align:center; font-size:9px;}'
			+ '.headding{background-color:' + color.header + '; color:white; font-weight:bold;}'
			+ '.row{background-color:' + color.evenrows + ';}'
			+ '.data{color:' + color.resnum + ';font-weight:bold;}'
			+ '.bar{background-color:' + color.bar + ';margin:1px 0 0 0;}'
			+ '.sum{background-color:' + color.footer + '; color:white; font-weight:bold;}'
			+ '.table{text-align:center;}'
			+ '--></style>';
	gs0[2] = '</head><body>'
		+ '<form action="" align=center><input type="submit" value="コピー" name="copy"></form>' //この行削除または行頭に『//』追加で、コピーボタン削除
		+ '<div class="period">' + toMyLocaleString(st) + ' ～ ' + toMyLocaleString( et ) + '</div>'
		+ '<table border="0" cellspacing="1" cellpadding="1" class="table">';
	gs0[3] = '<tr class="headding">'
				+ '<th align="center">Rank</th>'
				+ '<th align="center">ID</th>'
				+ '<' + hc[0] + 'th colspan="2" align="center">Res</th' + hc[5] + '>'
				+ '<' + hc[1] + 'th colspan="2" align="center">Ref</th' + hc[6] + '>'
				+ '<' + hc[2] + 'th align="center">Char</th' + hc[7] + '>'
				+ '<' + hc[3] + 'th align="center">Link</th' + hc[8] + '>'
				+ '<' + hc[4] + 'th align="center">NG</th' + hc[9] + '>'
			+ '</tr>';
	gsa[0] = '<tr>'
				+ '<td align="right">'; gsa[2] = '&nbsp;</td>'
				+ '<td align="left">&nbsp;&nbsp;'; gsa[4] = '&nbsp;</td>'
				+ '<' + hc[0] + 'td class="data" align="right">'; gsa[6] = '&nbsp;</td' + hc[5] + '>'
				+ '<' + hc[0] + 'td>'; gsa[8] = '<div class="bar" style="width: '; gsa[10] = ';"></div></td' + hc[5] + '>'
				+ '<' + hc[1] + 'td class="data" align="right">'; gsa[12] = '&nbsp;</td' + hc[6] + '>'
				+ '<' + hc[1] + 'td>'; gsa[14] = '<div class="bar" style="width: '; gsa[16] = ';"></div></td' + hc[6] + '>'
				+ '<' + hc[2] + 'td class="data" align="center">'; gsa[18] = '</td' + hc[7] + '>'
				+ '<' + hc[3] + 'td class="data" align="center">'; gsa[20] = '</td' + hc[8] + '>'
				+ '<' + hc[4] + 'td class="data" align="center">'; gsa[22] = '</td' + hc[9] + '>'
			+ '</tr>';
	for ( var m = 0,n = 0; m < ml; m++ ) {
		m%2 ==1 ? gsa[0] = '<tr class="row"><td align="right">' : gsa[0] = '<tr><td align="right">';
		switch( sort_column ){
			case '1' : //被参照数
				n = checkSameRank( ref_count, mres[m].refcount, n );
				break;
			case '2' : //文字数
				n = checkSameRank( char_count, mres[m].charcount, n );
				break;
			case '3' : //リンク数
				n = checkSameRank( link_count, mres[m].linkcount, n );
				break;
			case '4' : //ＮＧレス数
				n = checkSameRank( ng_count, mres[m].ngcount, n );
				break;
			default : //レス数
				n = checkSameRank( res_count, mres[m].rescount, n );
				break;
		}
		if ( n != null ) {
			if ( n == 0 ) {
				rank = m + 1 - n;
			}
		} else {
			if ( m == 0 ) {
				gs0.push( '<tr><td colspan="9" align="center">なし</td></tr>' );
			}
			break;
		}
		res_count = mres[m].rescount;
		ref_count = mres[m].refcount;
		char_count = mres[m].charcount;
		link_count = mres[m].linkcount;
		ng_count = mres[m].ngcount;

		gsa[1] = rank;
		gsa[3] = mres[m].id;
		gsa[5] = res_count;
		gsa[7] = '';
		if ( res_count > limited_bar ) {
			for ( var n = 0, c = Math.floor(res_count/limited_bar); n < c; n++ ) {
				gsa[7] += '<div class="bar" style="width: ' + limited_bar + ';"></div>';
			}
			gsa[9] = res_count%limited_bar;
		} else {
			gsa[9] = res_count;
		}
		gsa[11] = ref_count;
		gsa[13] = '';
		if ( ref_count > limited_bar ) {
			for ( var n = 0,c = Math.floor(ref_count/limited_bar); n < c; n++ ) {
				gsa[13] += '<div class="bar" style="width: ' + limited_bar + ';"></div>';
			}
			gsa[15] = ref_count%limited_bar;
		} else {
			gsa[15] = ref_count;
		}
		gsa[17] = char_count;
		gsa[19] = link_count;
		gsa[21] = ng_count;
		if ( rank > threshold) {
			break;
		} else {
			gs0.push( gsa.join( "" ) );
		}
	}
	gs0.push('<tr class="sum" align="left">'
				+ '<td>Total:&nbsp;</td>'
				+ '<td colspan="8">' + allres + ' レス/' + ml + ' 人 ( ' + Math.ceil(allres/ml*100)/100 + ' レス/1 人 )&nbsp;</td>'
			+ '</tr>');
	gs0.push( '</table></body></html>' );
	GraphString = gs0.join('');
	if ( res_pane ) {
		vcx.setResPaneHTML( GraphString,'IDランキング' );
	} else {
		vcx.setPopupFocusable( true );
		vcx.setPopupHTML( GraphString );
	}
	vcx.setTrapFormSubmission( true );
}

//入力データをcreateIdRankGraph()に渡す
function formSubmitted( u, sm, sd ) {
	if( sd.indexOf('copy=') == 0 ) {
		v2c.println(GraphString);
		copyTable( GraphString );
		return;
	}
	vcx.closeOriginalPopup();
	m1=sd.match( /\d+/g );
	start_time = new Date( m1[0], m1[1] - 1, m1[2], m1[3], m1[4], m1[5] );
	end_time = new Date( m1[6], m1[7] - 1, m1[8], m1[9], m1[10], m1[11] );
	sort_column = m1[12];
	threshold = m1[13];
	m2=sd.match( /v=\d+/g ) || [];
	view_column = ['','','','',''];
	for ( var i = j = 0, il=m2.length; i < il; i++ ) {
		j = ( m2[i] + '' ).replace( 'v=', '' );
		 view_column[j] = 'checked';
	}
	m3=sd.match(/o=\d+/g) || [];
	temp_settings = ['','','',''];
	for ( var k = 0, lk = m3.length; k < lk; k++ ) {
		j = ( m3[k] + '' ).replace( 'o=', '' );
		temp_settings[j] = 'checked';
	}
	if ( sd.indexOf( '&tt=' ) > -1 || save_and_submit ) {
		cmdArr = v2c.readLinesFromFile( txt, cecd );
		for ( var n = 0, nl = cmdArr.length; n < nl; n++ ) {
			cmdArr[n] = cmdArr[n] + '';
			if ( cmdArr[n].indexOf( "[TempSettings]" ) != -1 ) sw = 1;
			else {
				switch( sw ){
					case 1:
						mt = cmdArr[n].match( /^(StartTime|EndTime|Threshold|SortColumn|ViewColumn)=(.*)$/ );
						if ( !mt ) continue;
						if ( mt[1] == 'StartTime') {
							temp_settings[0] == 'checked' ? cmdArr[n] = 'StartTime=' + [m1[0],m1[1],m1[2],m1[3],m1[4],m1[5]] : cmdArr[n] = 'StartTime=';
						} else if(mt[1] == 'EndTime') {
							temp_settings[1] == 'checked' ? cmdArr[n] = 'EndTime=' + [m1[6],m1[7],m1[8],m1[9],m1[10],m1[11]] : cmdArr[n] = 'EndTime=';
						} else if(mt[1] == 'Threshold') {
							temp_settings[2] == 'checked' ? cmdArr[n] = 'Threshold=' + threshold : cmdArr[n] = 'Threshold=';
						} else if(mt[1] == 'SortColumn') {
							temp_settings[2] == 'checked' ? cmdArr[n] = 'SortColumn=' + sort_column : cmdArr[n] = 'SortColumn=';
						} else if(mt[1] == 'ViewColumn') {
							temp_settings[3] == 'checked' ? cmdArr[n] = 'ViewColumn=' + view_column.join(',') : cmdArr[n] = 'ViewColumn=';
						}
						break;
					default:
				}
			}
		}
	}
	if( cmdArr ) v2c.writeLinesToFile( txt, cmdArr, cecd );
	if( sd.indexOf( '&tt=' ) == -1 ) {
		 createIdRankGraph( start_time.getTime(), end_time.getTime() );
	}

}

//データ入力ポップアップの表示
function inputGraphSetting() {
	var oldtime = present.getTime();
	var newtime = 0;
	//すべてのスレッドの最古レスと最新レスの時間を取得
	var thx;
	var ort;
	var lrt;
	for ( var i = 0, il = vrpx.threads.length; i < il; i++ ) {
		thx = vrpx.getThread( i );
		if( thx ) {
			ort = thx.getRes(0).time;
			if ( oldtime > ort ) {
				oldtime = ort;
			}
			lrt = thx.getRes( thx.localResCount - 1 ).time;
			if ( newtime < lrt ) {
				newtime = lrt;
			}
		}
	}
	var od = toMyLocaleString( oldtime );
	var nd = toMyLocaleString( newtime );
	for ( var j = 0, sc = ['','','','','']; j < 4; j++ ) {
		if ( sort_column == j ) {
			sc[j] = 'selected';
			break;
		}
	}
	var s = '<html>'
			+ '<head>'
			+ '<style type="text/css"><!--'
				+ 'body{background-color:#F5F5F5; margin:5px 0 5px 15px;}'
			+ '--></style>'
			+ '</head>'
			+ '<body>'
			+ '<form action="">'
				+ '<table border="0" cellspacing="1" cellpadding="1" style="font-size:10px;">'
					+ '<tr>'
						+ '<td colspan="13"><div>範囲： ' + od + ' ～ ' + nd + '</div></td>'
					+ '</tr>'
					+ '<tr>'
						+ '<td>開始：</td>'
						+ '<td><input type="text" size="5" maxlength="4" name="sy" value="' + start[0] + '"></td>'
						+ '<td>/ </td>'
						+ '<td><input type="text" size="3" maxlength="2" name="sm" value="' + start[1] + '"></td>'
						+ '<td>/ </td>'
						+ '<td><input type="text" size="3" maxlength="2" name="sd" value="' + start[2] + '"></td>'
						+ '<td>&nbsp;</td>'
						+ '<td><input type="text" size="3" maxlength="2" name="sh" value="' + start[3] + '"></td>'
						+ '<td>：</td>'
						+ '<td><input type="text" size="3" maxlength="2" name="sm" value="' + start[4] + '"></td>'
						+ '<td>：</td>'
						+ '<td><input type="text" size="3" maxlength="2" name="ss" value="' + start[5] + '"></td>'
					+ '</tr>'
					+ '<tr>'
						+ '<td>終了：</td>'
						+ '<td><input type="text" size="5" maxlength="4" name="ey" value="' + end[0] + '"></td>'
						+ '<td>/ </td>'
						+ '<td><input type="text" size="3" maxlength="2" name="em" value="' + end[1] + '"></td>'
						+ '<td>/ </td>'
						+ '<td><input type="text" size="3" maxlength="2" name="ed" value="' + end[2] + '"></td>'
						+ '<td>&nbsp;</td>'
						+ '<td><input type="text" size="3" maxlength="2" name="eh" value="' + end[3] + '"></td>'
						+ '<td>：</td>'
						+ '<td><input type="text" size="3" maxlength="2" name="em" value="' + end[4] + '"></td>'
						+ '<td>：</td>'
						+ '<td><input type="text" size="3" maxlength="2" name="es" value="' + end[5] + '"></td>'
					+ '</tr>'
					+ '<tr>'
						+ '<td>閾値：</td>'
						+ '<td colspan="4">'
							+ '<div>'
								+ '<select name="ct">'
									+ '<option value="0" ' + sc[0] + '>レス数'
									+ '<option value="1" ' + sc[1] + '>被参照数'
									+ '<option value="2" ' + sc[2] + '>文字数'
									+ '<option value="3" ' + sc[3] + '>リンク数'
									+ '<option value="4" ' + sc[4] + '>ＮＧレス数'
								+ '</select>'
							+ '</div>'
						+ '</td>'
						+ '<td>が</td>'
						+ '<td colspan="2"><input type="text" size="5" maxlength="4" name="hd" value="' + threshold + '"></td>'
						+ '<td colspan="5">位以内のＩＤ</td>'
					+ '</tr>'
					+ '<tr>'
						+ '<td>表示：</td>'
						+ '<td colspan="12">'
							+ '<div>'
								+ '<input type=checkbox name="rv" value=0 ' + view_column[0] + '>レス数'
								+ '<input type=checkbox name="fv" value=1 ' + view_column[1] + '>被参照数'
								+ '<input type=checkbox name="cv" value=2 ' + view_column[2] + '>文字数'
								+ '<input type=checkbox name="lv" value=3 ' + view_column[3] + '>リンク数'
								+ '<input type=checkbox name="gv" value=4 ' + view_column[4] + '>ＮＧレス数'
							+ '</div>'
						+ '</td>'
					+ '</tr>'
					+ '<tr>'
						+ '<td>保存：</td>'
						+ '<td colspan="12">'
							+ '<div>'
								+ '<input type=checkbox name="so" value=0 ' + temp_settings[0] + '>開始'
								+ '<input type=checkbox name="eo" value=1 ' + temp_settings[1] + '>終了'
								+ '<input type=checkbox name="to" value=2 ' + temp_settings[2] + '>閾値'
								+ '<input type=checkbox name="vo" value=3 ' + temp_settings[3] + '>表示'
							+ '</div>'
						+ '</td>'
					+ '</tr>'
				+ '</table>'
				+ '<input type="submit" name="sb" value="実行">'
				+ '<input type="reset" value="リセット">'
				+ '<input type="submit" name="tt" value="保存して閉じる">'
			+ '</form>'
			+ '</body>'
			+ '</html>';
	vcx.setPopupHTML( s );
	vcx.setPopupFocusable( true );
	vcx.setTrapFormSubmission( true );
}
if ( vcx.args[0] == 'respane' || vcx.args[1] == 'respane' ) res_pane = true;
if ( vcx.args[0] == 'input' ){
	inputGraphSetting();
} else {
	createIdRankGraph( today.getTime(), present.getTime() );
}
// ----- 前の行まで -----